'use strict';

var _require = require('./replace-class-names'),
    replaceClassNames = _require.replaceClassNames;

var _require2 = require('./utils'),
    getNodes = _require2.getNodes,
    markNodes = _require2.markNodes,
    getSelectors = _require2.getSelectors,
    getStyles = _require2.getStyles;

function createSerializer(styleSheet, classNameReplacer) {
  function test(val) {
    return val && !val.withStyles && val.$$typeof === Symbol.for('react.test.json');
  }

  function print(val, printer) {
    var nodes = getNodes(val);
    markNodes(nodes);
    var selectors = getSelectors(nodes);
    var styles = getStyles(selectors, styleSheet);
    var printedVal = printer(val);
    if (styles) {
      return replaceClassNames(selectors, styles, printedVal, classNameReplacer);
    } else {
      return printedVal;
    }
  }

  return { test, print };
}

// doing this to make it easier for users to mock things
// like switching between development mode and whatnot.
var getGlamorStyleSheet = function getGlamorStyleSheet() {
  return require('glamor').styleSheet;
};
var glamorSerializer = createSerializer(getGlamorStyleSheet);
createSerializer.test = glamorSerializer.test;
createSerializer.print = glamorSerializer.print;

module.exports = createSerializer;